<?php

namespace usual2970\redlock;

use Predis;

class Lock
{
    public $addr = '';
    private $client;
    private $randomStr;
    private $timeout = 200;
    const LOCK_PREFIX = "LOCK_";

    public function __construct($addr = '')
    {
        if ($addr) {
            $this->addr = $addr;
        }
        if ($this->addr) {
            $this->init();
        }
    }

    public function init()
    {
        parent::init();
        $this->client = new Predis\Client($this->addr);
        $this->randomStr = $this->randomStr();
    }

    public function lock($key)
    {
        $rs = $this->client->set(self::LOCK_PREFIX . $key, $this->randomStr, 'NX', 'PX', $this->timeout);

        return $rs ? true : false;

    }

    public function unLock($key)
    {
        $val = $this->client->get(self::LOCK_PREFIX . $key);
        if ($this->randomStr === $val) {
            $this->client->del(self::LOCK_PREFIX . $key);
        }
    }

    private function randomStr()
    {
        return md5(microtime() . rand(10000000, 99999999));
    }
}
